---
title: PerformancePaintTiming
slug: Web/API/PerformancePaintTiming
tags:
  - API
  - Interface
  - Paint Timing
  - Performance Timeline API
  - PerformancePaintTiming
  - Reference
  - Web Performance
---
<p>{{APIRef("Performance Timeline API")}}</p>

<p>The <strong><code>PerformancePaintTiming</code></strong> interface of the <a href="/en-US/docs/Web/API/Paint_Timing_API">Paint Timing API</a> provides timing information about "paint" (also called "render") operations during web page construction. "Paint" refers to conversion of the render tree to on-screen pixels.</p>

<p>An application can register a {{domxref("PerformanceObserver")}} for "<code>paint</code>" {{domxref("PerformanceEntry","performance entry types")}} and the observer can retrieve the times that paint events occur. Use this information to help identify areas that take too long to provide a good user experience.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Properties">Properties</h2>

<p>This interface has no properties but it extends the following {{domxref("PerformanceEntry")}} properties (for "<code>paint</code>" {{domxref ("PerformanceEntry.entryType","performance entry types")}}) by qualifying and constraining the properties as follows:</p>

<dl>
 <dt>{{domxref("PerformanceEntry.entryType")}}</dt>
 <dd>Returns "<code>paint</code>".</dd>
 <dt>{{domxref("PerformanceEntry.name")}}</dt>
 <dd>Returns either <code>"first-paint"</code> or <code>"first-contentful-paint"</code>.</dd>
 <dt>{{domxref("PerformanceEntry.startTime")}}</dt>
 <dd>Returns the {{domxref("DOMHighResTimeStamp","timestamp")}} when the paint occurred.</dd>
 <dt>{{domxref("PerformanceEntry.duration")}}</dt>
 <dd>Returns 0.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p>This interface has no methods.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js notranslate">function showPaintTimings() {
  if (window.performance) {
    let performance = window.performance;
    let performanceEntries = performance.getEntriesByType('paint');
    performanceEntries.forEach( (performanceEntry, i, entries) =&gt; {
      console.log("The time to " + performanceEntry.name + " was " + performanceEntry.startTime + " milliseconds.");
    });
  } else {
    console.log('Performance timing isn\'t supported.');
  }
}</pre>

<p>The code above produces console output something like the following:</p>

<pre class="notranslate">The time to first-paint was 2785.915 milliseconds.
The time to first-contentful-paint was 2787.460 milliseconds.</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Paint Timing','#sec-PerformancePaintTiming','PerformancePaintTiming')}}</td>
   <td>{{Spec2('Paint Timing')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PerformancePaintTiming")}}</p>
